﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using System.Xml.Serialization;

namespace GameCore
{
    public class TrafficScene
    {
        public static string MAPDIRECTORY = @"D:\DEV2021\Lesson3  - Adding Layers to the map - PART3\maps";

        public static string LOCATION_TILES = @"D:\DEV2021\Lesson3  - Adding Layers to the map - PART3\Traffic\GameCore\images\tiles";
        public static string LOCATION_CARS = @"D:\DEV2021\Lesson3  - Adding Layers to the map - PART3\Traffic\GameCore\images\\cars";
        public static string LOCATION_BUILDINGS = @"D:\DEV2021\Lesson3  - Adding Layers to the map - PART3\Traffic\GameCore\images\buildings";
        public static string LOCATION_LIGHTS = @"D:\DEV2021\Lesson3  - Adding Layers to the map - PART3\Traffic\GameCore\images\lights";

        public static string[] TILES = new[] {
            "gras",//0
            "asphalt",//1
            "concrete",//2
            "path",//3
            "pavement1", "pavement2", "pavement3", "pavement4",//7
            "pavementcorner1","pavementcorner2","pavementcorner3","pavementcorner4",//11
            "tilecorner1","tilecorner2","tilecorner3","tilecorner4",//15
            "tilepath1","tilepath2",//17
            "tilecross",//18
            "TileTSect1","TileTSect2","TileTSect3","TileTSect4",//22
            "pathcorner1","pathcorner2","pathcorner3","pathcorner4",//26
            "pathcross",//27
            "pathTSect1","pathTSect2","pathTSect3","pathTSect4",//31
            "pathway1","pathway2",//33
            "dirt1","dirt2","dirt3","dirt4","dirt5","dirt6",//39
            "dirtgrass1_1","dirtgrass1_2","dirtgrass1_3","dirtgrass1_4",//43
            "dirtgrass2_1","dirtgrass2_2","dirtgrass2_3","dirtgrass2_4",//47
            "dirtgrass3_1","dirtgrass3_2","dirtgrass3_3","dirtgrass3_4",//51
            "pedestriancrossing1", "pedestriancrossing2", //53
            "pedestriancrossingSmall1", "pedestriancrossingSmall2",//55
            "roundtiles",//56
            "dirt2path1", "dirt2path2",//58
            "dirt3path1", "dirt3path2",//60
            "dirt6path1", "dirt6path2",//62
            "dirt7","lava",//64
            "flower1_1","flower2_1",//66
            "flower3_1","flower4_1",//68
            "flower5_1","flower6_1",//70
            "smallstumps",//71
            "treestump1","treestump2",//73
            "lavacompact",//74
            "lavacorner1","lavacorner2","lavacorner3","lavacorner4",//78
            "lavafull1","lavafull2","lavafull3","lavafull4",//82
            "lavafullcorner1","lavafullcorner2","lavafullcorner3","lavafullcorner4",//86
            "lavaside1","lavaside2","lavaside3","lavaside4",//90
            "lavaside5","lavaside6","lavaside7","lavaside8",//94
            "lavaside9","lavaside10","lavaside11","lavaside12",//98
            "lavasmall1","lavasmall2",//100
            "lavastone1","lavastone2",//102
            "lavastone1path1","lavastone1path2",//104
            "lavastone2path1","lavastone2path2",//106
            "cornfield1_1","cornfield1_2","cornfield1_3","cornfield1_4",//110
            "colors"//111
        };
        public static string[] CARS = new[] {
            "BlackSedan1", "BlackSedan2", "BlackSedan3", "BlackSedan4",//3
            "BlueSedan1", "BlueSedan2","BlueSedan3","BlueSedan4",//7
            "CandySedan1", "CandySedan2","CandySedan3","CandySedan4",//11
            "GreenLorry1", "GreenLorry2","GreenLorry3","GreenLorry4",//15
            "GreenSedan1", "GreenSedan2","GreenSedan3","GreenSedan4",//19
            "PinkSedan1", "PinkSedan2","PinkSedan3","PinkSedan4",//23
            "WhiteSedan1", "WhiteSedan2","WhiteSedan3","WhiteSedan4",//27
            "YellowSedan1", "YellowSedan2","YellowSedan3","YellowSedan4",//31
            "BlueTruck1","BlueTruck2","BlueTruck3","BlueTruck4",//35
            "BrownTruck1","BrownTruck2","BrownTruck3","BrownTruck4",//39
            "GreenTruck1","GreenTruck2","GreenTruck3","GreenTruck4",//43
            "RedTruck1","RedTruck2","RedTruck3","RedTruck4",//47
            "BlueVan1_1","BlueVan1_2","BlueVan1_3","BlueVan1_4",//51
            "BlueVan2_1","BlueVan2_2","BlueVan2_3","BlueVan2_4",//55
            "BlueVan3_1","BlueVan3_2","BlueVan3_3","BlueVan3_4",//59
            "WhiteVan1_1","WhiteVan1_2","WhiteVan1_3","WhiteVan1_4",//63
            "WhiteVan2_1","WhiteVan2_2","WhiteVan2_3","WhiteVan2_4",//67
            "WhiteVan3_1","WhiteVan3_2","WhiteVan3_3","WhiteVan3_4",//71
            "SmartCarBlue1", "SmartCarBlue2","SmartCarBlue3","SmartCarBlue4",//75
            "SmartCarGreen1","SmartCarGreen2","SmartCarGreen3","SmartCarGreen4",//79
            "SmartCarOffWhite1","SmartCarOffWhite2","SmartCarOffWhite3","SmartCarOffWhite4",//83
            "SmartCarPaleGray1","SmartCarPaleGray2","SmartCarPaleGray3","SmartCarPaleGray4",//87
            "SmartCarPurple1","SmartCarPurple2","SmartCarPurple3","SmartCarPurple4",//91
            "SmartCarRed1","SmartCarRed2","SmartCarRed3","SmartCarRed4",//95
            "SmartCarYellow1","SmartCarYellow2","SmartCarYellow3","SmartCarYellow4",//99
            "RainbowVan1","RainbowVan2","RainbowVan3","RainbowVan4",//103
            "BlackHatch1","BlackHatch2","BlackHatch3","BlackHatch4",//107
            "BlackHatchRoof1","BlackHatchRoof2","BlackHatchRoof3","BlackHatchRoof4",//111
            "DarkblueHatch1","DarkblueHatch2","DarkblueHatch3","DarkblueHatch4",//115
            "DarkblueHatchRoof1","DarkblueHatchRoof2","DarkblueHatchRoof3","DarkblueHatchRoof4",//119
            "DarkdarkgrayHatch1","DarkdarkgrayHatch2","DarkdarkgrayHatch3","DarkdarkgrayHatch4",//123
            "DarkdarkgrayHatchRoof1","DarkdarkgrayHatchRoof2","DarkdarkgrayHatchRoof3","DarkdarkgrayHatchRoof4",//127
            "DarkgreenHatch1","DarkgreenHatch2","DarkgreenHatch3","DarkgreenHatch4",//131
            "DarkgreenHatchRoof1","DarkgreenHatchRoof2","DarkgreenHatchRoof3","DarkgreenHatchRoof4",//135
            "DarkredHatch1","DarkredHatch2","DarkredHatch3","DarkredHatch4",//139
            "DarkredHatchRoof1","DarkredHatchRoof2","DarkredHatchRoof3","DarkredHatchRoof4",//143
            "GrayHatch1","GrayHatch2","GrayHatch3","GrayHatch4",//147
            "GrayHatchRoof1","GrayHatchRoof2","GrayHatchRoof3","GrayHatchRoof4",//151
            "GreenHatch1","GreenHatch2","GreenHatch3","GreenHatch4",//155
            "GreenHatchRoof1","GreenHatchRoof2","GreenHatchRoof3","GreenHatchRoof4",//159
            "LightGrayHatch1","LightGrayHatch2","LightGrayHatch3","LightGrayHatch4",//163
            "LightGrayHatchRoof1","LightGrayHatchRoof2","LightGrayHatchRoof3","LightGrayHatchRoof4",//167
            "MedGrayHatch1","MedGrayHatch2","MedGrayHatch3","MedGrayHatch4",//171
            "MedGrayHatchRoof1","MedGrayHatchRoof2","MedGrayHatchRoof3","MedGrayHatchRoof4",//175
            "OrangeHatch1","OrangeHatch2","OrangeHatch3","OrangeHatch4",//179
            "OrangeHatchRoof1","OrangeHatchRoof2","OrangeHatchRoof3","OrangeHatchRoof4",//183
            "PaleBlueHatch1","PaleBlueHatch2","PaleBlueHatch3","PaleBlueHatch4",//187
            "PaleBlueHatchRoof1","PaleBlueHatchRoof2","PaleBlueHatchRoof3","PaleBlueHatchRoof4",//191
            "PaleWhiteHatch1","PaleWhiteHatch2","PaleWhiteHatch3","PaleWhiteHatch4",//195
            "PaleWhiteHatchRoof1","PaleWhiteHatchRoof2","PaleWhiteHatchRoof3","PaleWhiteHatchRoof4",//199
            "PurpleHatch1","PurpleHatch2","PurpleHatch3","PurpleHatch4",//203
            "PurpleHatchRoof1","PurpleHatchRoof2","PurpleHatchRoof3","PurpleHatchRoof4",//207
            "RedHatch1","RedHatch2","RedHatch3","RedHatch4",//211
            "RedHatchRoof1","RedHatchRoof2","RedHatchRoof3","RedHatchRoof4",//215
            "WhiteHatch1","WhiteHatch2","WhiteHatch3","WhiteHatch4",//219
            "YellowHatch1","YellowHatch2","YellowHatch3","YellowHatch4",//223
            "YellowHatchRoof1","YellowHatchRoof2","YellowHatchRoof3","YellowHatchRoof4",//227
            "TestVan1","TestVan2","TestVan3","TestVan4",
        };
        public static string[] BUILDINGS = new[] {
            "BaracksA",
            "Factory1A",
            "Factory2A",
            "Factory3A",
            "Finance1A",
            "Finance2A",//5 
            "Finance3A",
            "FiveFloorAptsA",
            "Office1A",
            "SchoolA",
            "SevenFloorAptsA", //10
            "SixFloorAptsA",
            "ThreeFloorAptsA",
            "Tower1A",
            "Tower2A",
            "TwoStoryHouse1", "TwoStoryHouse2", //16
            "Shop1", "Shop2", //18
            "House2A", "House2B", //20
            "House3A", "House3B", //22
            "House4A", "House4B", //24
            "BaracksB", //25
            "Factory1B",
            "Factory2B",
            "Factory3B",
            "Finance1B",
            "Finance2B", //30
            "Finance3B",
            "FiveFloorAptsB",
            "Office1B",
            "SchoolB",
            "SevenFloorAptsB", //35
            "SixFloorAptsB",
            "ThreeFloorAptsB",
            "Tower1B",
            "Tower2B",//39
            "FireDept", "FireDeptB",//41
            "Hospital", "HospitalB",//43
            "Police", "PoliceB",//45
            "School2","School2B",//47
            "Tower3","Tower3B",//49
            "Tree1Clean","Tree1Clean2","Tree3Clean","Tree3Clean2","Tree4Clean","Tree4Clean2",//55
            "Tree5Clean","Tree5Clean2","Bush1","Bush2",//59
            "BoligblokBrickDark1","BoligblokBrickDark2",//61
            "Tree6Clean","Tree6Clean2",//63
            "BoligblokBrick1","BoligblokBrick2",//65
            "BoligblokRed1","BoligblokRed2",//67
            "BoligblokWhite1","BoligblokWhite2",//69
            "BoligblokFacaded1","BoligblokFacaded2",//71
            "BoligblokHjoerne",//72
            "shed1","shed2","mast1Gray",//75
            "shed3","shed4","shedBare1","shedBare2",//79
            "BoligBlokGray1","BoligBlokGray2",//81
            "BeamHorizontal","BeamHorizontal2",//83
            "BeamSolid","BeamSolid2",//85
            "signlargeback", "signlargeback2",//87
            "signlargeblue1", "signlargeblue2",//89
            "signSmall1","signSmall2",//91
            "signSmallback","signSmallback2",//93
            "signSmall3","signSmall4",//95
            "TreeClipartLarge","TreeClipartLarge2",//97
            "TreeLargeOak","TreeLargeOak2",//99
            "TreeLargeWide","TreeLargeWide2",//101
            "Shop1","Shop2",//103
            "BoligBlok4A","BoligBlok4B",//105
            "BoligBlokYellow1","BoligBlokYellow2",//107
            "BoligBlokTagpap2A","BoligBlokTagpap2B",//109
            "powerstation1","powerstation2",//111
            "headquarters_upgrade1A","headquarters_upgrade1B",//113
            "headquarters_upgrade2A","headquarters_upgrade2B",//115
            "headquarters_upgrade3A","headquarters_upgrade3B",//117
            "headquarters_upgrade4A","headquarters_upgrade4B",//119
            "Hospital_upgrade1A","Hospital_upgrade1B",//121
            "Hospital_upgrade2A","Hospital_upgrade2B",//123
            "Hospital_upgrade3A","Hospital_upgrade3B",//125
            "Hospital_upgrade4A","Hospital_upgrade4B",//127
            "Legal_upgrade1A","Legal_upgrade1B",//129
            "Legal_upgrade2A","Legal_upgrade2B",//131
            "Legal_upgrade3A","Legal_upgrade3B",//133
            "Legal_upgrade4A","Legal_upgrade4B",//135
            "workshop_upgrade1A","workshop_upgrade1B",//137
            "workshop_upgrade2A","workshop_upgrade2B",//139
            "workshop_upgrade3A","workshop_upgrade3B",//141
            "workshop_upgrade4A","workshop_upgrade4B",//143
            //Small nature elements
            "SmallTree1Clean","SmallTree1Clean2",//197
            "SmallTree3Clean","SmallTree3Clean2",//199
            "SmallTree4Clean","SmallTree4Clean2",//201
            "SmallTree5Clean","SmallTree5Clean2",//203
            "SmallTreeClipartLarge","SmallTreeClipartLarge2",//205
            "SmallTreeLargeOak","SmallTreeLargeOak2",//207
            "SmallTreeLargeWide","SmallTreeLargeWide2",//209
        };
        public static string[] LIGHTS = new[] {
            "CarGreenWalkRed_25pct", "CarGreenWalkRed_25pct_mirror", "CarRedWalkGreen_25pct", "CarRedWalkGreen_25pct_mirror",//3
            "CarYellowWalkRed_25pct", "CarYellowWalkRed_25pct_mirror", //5
            "core_trafficlight_backside_25pct" , "core_trafficlight_backside_25pct_mirror",//7
            "trafficlight_backsideFrontCarGreen_25pct", "trafficlight_backsideFrontCarGreen_25pct_mirror",//9
            "trafficlight_backsideFrontCarRed_25pct", "trafficlight_backsideFrontCarRed_25pct_mirror",//11
            "trafficlight_backsideFrontCarYellow_25pct", "trafficlight_backsideFrontCarYellow_25pct_mirror",//13
            "trafficlight_backsideFrontGreen_25pct", "trafficlight_backsideFrontGreen_25pct_mirror",//15
            "trafficlight_backsideFrontRed_25pct", "trafficlight_backsideFrontRed_25pct_mirror",//17
            "lamp1","lamp2","lamp3","lamp4","lamptwo1","lamptwo2",//23
            "tlBack1", "tlBack2", "tlGreen", "tlRed","tlYellow", "tlGreen2", "tlRed2", "tlYellow2",//31
        };

        public static List<TileTemplate> DESIGNTEMPLATES_TILES = new List<TileTemplate> {
            new TileTemplate {Name = "Grass", Type = TemplateType.Tile, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = 0, ImageIndexSW = 0, ImageIndexNW = 0},
            new TileTemplate {Name = "Asphalt",  Type = TemplateType.Tile, ImageIndex = 1, ImageIndexSE = 1, ImageIndexNE = 1, ImageIndexSW = 1, ImageIndexNW = 1},
            new TileTemplate {Name = "Concrete",  Type = TemplateType.Tile, ImageIndex = 2, ImageIndexSE = 2, ImageIndexNE = 2, ImageIndexSW = 2, ImageIndexNW = 2},
            new TileTemplate {Name = "Path",  Type = TemplateType.Tile, ImageIndex = 3, ImageIndexSE = 3, ImageIndexNE = 3, ImageIndexSW = 3, ImageIndexNW = 3},
            //Modern Traffic tiles
            //new TileTemplate {Name = "Pavement",  Type = TemplateType.Tile, ImageIndex = 4, ImageIndexSE = 4, ImageIndexNE = 5, ImageIndexSW = 6, ImageIndexNW = 7},
            //new TileTemplate {Name = "Pavement Corner",  Type = TemplateType.Tile, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = 9, ImageIndexSW = 10, ImageIndexNW = 11},
            //new TileTemplate {Name = "Tile Corner",  Type = TemplateType.Tile, ImageIndex = 12, ImageIndexSE = 12, ImageIndexNE = 13, ImageIndexSW = 14, ImageIndexNW = 15},
            //new TileTemplate {Name = "Tile Path",  Type = TemplateType.Tile, ImageIndex = 16, ImageIndexSE = 16, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 17},
            //new TileTemplate {Name = "Tile Cross",  Type = TemplateType.Tile, ImageIndex = 18, ImageIndexSE = 18, ImageIndexNE = 18, ImageIndexSW = 18, ImageIndexNW = 18},
            //new TileTemplate {Name = "Tile T-Section",  Type = TemplateType.Tile, ImageIndex = 19, ImageIndexSE = 19, ImageIndexNE = 20, ImageIndexSW = 21, ImageIndexNW = 22},
            new TileTemplate {Name = "Path Corner",  Type = TemplateType.Tile, ImageIndex = 23, ImageIndexSE = 23, ImageIndexNE = 24, ImageIndexSW = 25, ImageIndexNW = 26},
            new TileTemplate {Name = "Path Cross",  Type = TemplateType.Tile, ImageIndex = 27, ImageIndexSE = 27, ImageIndexNE = 27, ImageIndexSW = 27, ImageIndexNW = 27},
            new TileTemplate {Name = "Path T-Section",  Type = TemplateType.Tile, ImageIndex = 28, ImageIndexSE = 28, ImageIndexNE = 29, ImageIndexSW = 30, ImageIndexNW = 31},
            new TileTemplate {Name = "Dirt Path",  Type = TemplateType.Tile, ImageIndex = 32, ImageIndexSE = 32, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 33},
            new TileTemplate {Name = "Dirt 1", Type = TemplateType.Tile, ImageIndex = 34, ImageIndexSE = 34, ImageIndexNE = 34, ImageIndexSW = 34, ImageIndexNW = 34},
            new TileTemplate {Name = "Dirt 2", Type = TemplateType.Tile, ImageIndex = 35, ImageIndexSE = 35, ImageIndexNE = 35, ImageIndexSW = 35, ImageIndexNW = 35},
            new TileTemplate {Name = "Dirt 3", Type = TemplateType.Tile, ImageIndex = 36, ImageIndexSE = 36, ImageIndexNE = 36, ImageIndexSW = 36, ImageIndexNW = 36},
            new TileTemplate {Name = "Dirt 4", Type = TemplateType.Tile, ImageIndex = 37, ImageIndexSE = 37, ImageIndexNE = 37, ImageIndexSW = 37, ImageIndexNW = 37},
            new TileTemplate {Name = "Dirt 5", Type = TemplateType.Tile, ImageIndex = 38, ImageIndexSE = 38, ImageIndexNE = 38, ImageIndexSW = 38, ImageIndexNW = 38},
            new TileTemplate {Name = "Dirt 6", Type = TemplateType.Tile, ImageIndex = 39, ImageIndexSE = 39, ImageIndexNE = 39, ImageIndexSW = 39, ImageIndexNW = 39},
            new TileTemplate {Name = "Dirt Grass 1", Type = TemplateType.Tile, ImageIndex = 40, ImageIndexSE = 40, ImageIndexNE = 41, ImageIndexSW = 42, ImageIndexNW = 43},
            new TileTemplate {Name = "Dirt Grass 2", Type = TemplateType.Tile, ImageIndex = 44, ImageIndexSE = 44, ImageIndexNE = 45, ImageIndexSW = 46, ImageIndexNW = 47},
            new TileTemplate {Name = "Dirt Grass 3", Type = TemplateType.Tile, ImageIndex = 48, ImageIndexSE = 48, ImageIndexNE = 49, ImageIndexSW = 50, ImageIndexNW = 51},
            //Modern Traffic tiles
            //new TileTemplate {Name = "Pedestrian Crossing",  Type = TemplateType.Tile, ImageIndex = 52, ImageIndexSE = 52, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 53},
            //new TileTemplate {Name = "Pedestrian Crossing Small",  Type = TemplateType.Tile, ImageIndex = 54, ImageIndexSE = 54, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 55},
            new TileTemplate {Name = "Round Tile",  Type = TemplateType.Tile, ImageIndex = 56, ImageIndexSE = 56, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 56},
            new TileTemplate {Name = "Dirt 2 path", Type = TemplateType.Tile, ImageIndex = 57, ImageIndexSE = 57, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 58},
            new TileTemplate {Name = "Dirt 3 path", Type = TemplateType.Tile, ImageIndex = 59, ImageIndexSE = 59, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 60},
            new TileTemplate {Name = "Dirt 6 path", Type = TemplateType.Tile, ImageIndex = 61, ImageIndexSE = 61, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 62},

            new TileTemplate {Name = "Dirt 7", Type = TemplateType.Tile, ImageIndex = 63, ImageIndexSE = 63, ImageIndexNE = 63, ImageIndexSW = 63, ImageIndexNW = 63},
            new TileTemplate {Name = "Lava", Type = TemplateType.Tile, ImageIndex = 64, ImageIndexSE = 64, ImageIndexNE = 64, ImageIndexSW = 64, ImageIndexNW = 64},
            new TileTemplate {Name = "Flower 1", Type = TemplateType.Tile, ImageIndex = 65, ImageIndexSE = 65, ImageIndexNE = 65, ImageIndexSW = 65, ImageIndexNW = 65},
            new TileTemplate {Name = "Flower 2", Type = TemplateType.Tile, ImageIndex = 66, ImageIndexSE = 66, ImageIndexNE = 66, ImageIndexSW = 66, ImageIndexNW = 66},
            new TileTemplate {Name = "Flower 3", Type = TemplateType.Tile, ImageIndex = 67, ImageIndexSE = 67, ImageIndexNE = 67, ImageIndexSW = 67, ImageIndexNW = 67},
            new TileTemplate {Name = "Flower 4", Type = TemplateType.Tile, ImageIndex = 68, ImageIndexSE = 68, ImageIndexNE = 68, ImageIndexSW = 68, ImageIndexNW = 68},
            new TileTemplate {Name = "Flower 5", Type = TemplateType.Tile, ImageIndex = 69, ImageIndexSE = 69, ImageIndexNE = 69, ImageIndexSW = 69, ImageIndexNW = 69},
            new TileTemplate {Name = "Flower 6", Type = TemplateType.Tile, ImageIndex = 70, ImageIndexSE = 70, ImageIndexNE = 70, ImageIndexSW = 70, ImageIndexNW = 70},
            new TileTemplate {Name = "SmallStumps", Type = TemplateType.Tile, ImageIndex = 71, ImageIndexSE = 71, ImageIndexNE = 71, ImageIndexSW = 71, ImageIndexNW = 71},
            new TileTemplate {Name = "Tree Stump", Type = TemplateType.Tile, ImageIndex = 72, ImageIndexSE = 72, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 73},
};
        public static List<TileTemplate> DESIGNTEMPLATES_CARS = new List<TileTemplate> {
            new TileTemplate {Name = "Black Sedan", Type = TemplateType.Car, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = 1, ImageIndexSW = 2, ImageIndexNW = 3},
            new TileTemplate {Name = "Blue Sedan", Type = TemplateType.Car, ImageIndex = 4, ImageIndexSE = 4, ImageIndexNE = 5, ImageIndexSW = 6, ImageIndexNW = 7},
            new TileTemplate {Name = "Candy Sedan", Type = TemplateType.Car, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = 9, ImageIndexSW = 10, ImageIndexNW = 11},
            new TileTemplate {Name = "Green Lorry", Type = TemplateType.Car, ImageIndex = 12, ImageIndexSE = 12, ImageIndexNE = 13, ImageIndexSW = 14, ImageIndexNW = 15},
            new TileTemplate {Name = "Green Sedan", Type = TemplateType.Car, ImageIndex = 16, ImageIndexSE = 16, ImageIndexNE = 17, ImageIndexSW = 18, ImageIndexNW = 19},
            new TileTemplate {Name = "Pink Sedan", Type = TemplateType.Car, ImageIndex = 20, ImageIndexSE = 20, ImageIndexNE = 21, ImageIndexSW = 22, ImageIndexNW = 23},
            new TileTemplate {Name = "White Sedan", Type = TemplateType.Car, ImageIndex = 24, ImageIndexSE = 24, ImageIndexNE = 25, ImageIndexSW = 26, ImageIndexNW = 27},
            new TileTemplate {Name = "Yellow Sedan", Type = TemplateType.Car, ImageIndex = 28, ImageIndexSE = 28, ImageIndexNE = 29, ImageIndexSW = 30, ImageIndexNW = 31},
            new TileTemplate {Name = "Blue Truck", Type = TemplateType.Car, ImageIndex = 32, ImageIndexSE = 32, ImageIndexNE = 33, ImageIndexSW = 34, ImageIndexNW = 35},
            new TileTemplate {Name = "Brown Truck", Type = TemplateType.Car, ImageIndex = 36, ImageIndexSE = 36, ImageIndexNE = 37, ImageIndexSW = 38, ImageIndexNW = 39},
            new TileTemplate {Name = "Green Truck", Type = TemplateType.Car, ImageIndex = 40, ImageIndexSE = 40, ImageIndexNE = 41, ImageIndexSW = 42, ImageIndexNW = 43},
            new TileTemplate {Name = "Red Truck", Type = TemplateType.Car, ImageIndex = 44, ImageIndexSE = 44, ImageIndexNE = 45, ImageIndexSW = 46, ImageIndexNW = 47},
            new TileTemplate {Name = "Blue Van1", Type = TemplateType.Car, ImageIndex = 48, ImageIndexSE = 48, ImageIndexNE = 49, ImageIndexSW = 50, ImageIndexNW = 51},
            new TileTemplate {Name = "Blue Van2", Type = TemplateType.Car, ImageIndex = 52, ImageIndexSE = 52, ImageIndexNE = 53, ImageIndexSW = 54, ImageIndexNW = 55},
            new TileTemplate {Name = "Blue Van3", Type = TemplateType.Car, ImageIndex = 56, ImageIndexSE = 56, ImageIndexNE = 57, ImageIndexSW = 58, ImageIndexNW = 59},
            new TileTemplate {Name = "White Van1", Type = TemplateType.Car, ImageIndex = 60, ImageIndexSE = 60, ImageIndexNE = 61, ImageIndexSW = 62, ImageIndexNW = 63},
            new TileTemplate {Name = "White Van2", Type = TemplateType.Car, ImageIndex = 64, ImageIndexSE = 64, ImageIndexNE = 65, ImageIndexSW = 66, ImageIndexNW = 67},
            new TileTemplate {Name = "White Van3", Type = TemplateType.Car, ImageIndex = 68, ImageIndexSE = 68, ImageIndexNE = 69, ImageIndexSW = 70, ImageIndexNW = 71},
            new TileTemplate {Name = "Blue Smartcar", Type = TemplateType.Car, ImageIndex = 72, ImageIndexSE = 72, ImageIndexNE = 73, ImageIndexSW = 74, ImageIndexNW = 75},
            new TileTemplate {Name = "Green Smartcar", Type = TemplateType.Car, ImageIndex = 76, ImageIndexSE = 76, ImageIndexNE = 77, ImageIndexSW = 78, ImageIndexNW = 79},
            new TileTemplate {Name = "Offwhite Smartcar", Type = TemplateType.Car, ImageIndex = 80, ImageIndexSE = 80, ImageIndexNE = 81, ImageIndexSW = 82, ImageIndexNW = 83},
            new TileTemplate {Name = "Palegray Smartcar", Type = TemplateType.Car, ImageIndex = 84, ImageIndexSE = 84, ImageIndexNE = 85, ImageIndexSW = 86, ImageIndexNW = 87},
            new TileTemplate {Name = "Purple Smartcar", Type = TemplateType.Car, ImageIndex = 88, ImageIndexSE = 88, ImageIndexNE = 89, ImageIndexSW = 90, ImageIndexNW = 91},
            new TileTemplate {Name = "Red Smartcar", Type = TemplateType.Car, ImageIndex = 92, ImageIndexSE = 92, ImageIndexNE = 93, ImageIndexSW = 94, ImageIndexNW = 95},
            new TileTemplate {Name = "Yellow Smartcar", Type = TemplateType.Car, ImageIndex = 96, ImageIndexSE = 96, ImageIndexNE = 97, ImageIndexSW = 98, ImageIndexNW = 99},
            new TileTemplate {Name = "Rainbow Van", Type = TemplateType.Car, ImageIndex = 100, ImageIndexSE = 100, ImageIndexNE = 101, ImageIndexSW = 102, ImageIndexNW = 103},
            new TileTemplate {Name = "Black Hatchback", Type = TemplateType.Car, ImageIndex = 104, ImageIndexSE = 104, ImageIndexNE = 105, ImageIndexSW = 106, ImageIndexNW = 107},
            new TileTemplate {Name = "Black Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 108, ImageIndexSE = 108, ImageIndexNE = 109, ImageIndexSW = 110, ImageIndexNW = 111},
            new TileTemplate {Name = "Darkblue Hatchback", Type = TemplateType.Car, ImageIndex = 112, ImageIndexSE = 112, ImageIndexNE = 113, ImageIndexSW = 114, ImageIndexNW = 115},
            new TileTemplate {Name = "Darkblue Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 116, ImageIndexSE = 116, ImageIndexNE = 117, ImageIndexSW = 118, ImageIndexNW = 119},
            new TileTemplate {Name = "Darkgray Hatchback", Type = TemplateType.Car, ImageIndex = 120, ImageIndexSE = 120, ImageIndexNE = 121, ImageIndexSW = 122, ImageIndexNW = 123},
            new TileTemplate {Name = "Darkgray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 124, ImageIndexSE = 124, ImageIndexNE = 125, ImageIndexSW = 126, ImageIndexNW = 127},
            new TileTemplate {Name = "Darkgreen Hatchback", Type = TemplateType.Car, ImageIndex = 128, ImageIndexSE = 128, ImageIndexNE = 129, ImageIndexSW = 130, ImageIndexNW = 131},
            new TileTemplate {Name = "Darkgreen Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 132, ImageIndexSE = 132, ImageIndexNE = 133, ImageIndexSW = 134, ImageIndexNW = 135},
            new TileTemplate {Name = "Darkred Hatchback", Type = TemplateType.Car, ImageIndex = 136, ImageIndexSE = 136, ImageIndexNE = 137, ImageIndexSW = 138, ImageIndexNW = 139},
            new TileTemplate {Name = "Darkred Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 140, ImageIndexSE = 140, ImageIndexNE = 141, ImageIndexSW = 142, ImageIndexNW = 143},
            new TileTemplate {Name = "Gray Hatchback", Type = TemplateType.Car, ImageIndex = 144, ImageIndexSE = 144, ImageIndexNE = 145, ImageIndexSW = 146, ImageIndexNW = 147},
            new TileTemplate {Name = "Gray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 148, ImageIndexSE = 148, ImageIndexNE = 149, ImageIndexSW = 150, ImageIndexNW = 151},
            new TileTemplate {Name = "Green Hatchback", Type = TemplateType.Car, ImageIndex = 152, ImageIndexSE = 152, ImageIndexNE = 153, ImageIndexSW = 154, ImageIndexNW = 155},
            new TileTemplate {Name = "Green Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 156, ImageIndexSE = 156, ImageIndexNE = 157, ImageIndexSW = 158, ImageIndexNW = 159},
            new TileTemplate {Name = "Lightgray Hatchback", Type = TemplateType.Car, ImageIndex = 160, ImageIndexSE = 160, ImageIndexNE = 161, ImageIndexSW = 162, ImageIndexNW = 163},
            new TileTemplate {Name = "Lightgray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 164, ImageIndexSE = 164, ImageIndexNE = 165, ImageIndexSW = 166, ImageIndexNW = 167},
            new TileTemplate {Name = "Mediumgray Hatchback", Type = TemplateType.Car, ImageIndex = 168, ImageIndexSE = 168, ImageIndexNE = 169, ImageIndexSW = 170, ImageIndexNW = 171},
            new TileTemplate {Name = "Mediumgray Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 172, ImageIndexSE = 172, ImageIndexNE = 173, ImageIndexSW = 174, ImageIndexNW = 175},
            new TileTemplate {Name = "Orange Hatchback", Type = TemplateType.Car, ImageIndex = 176, ImageIndexSE = 176, ImageIndexNE = 177, ImageIndexSW = 178, ImageIndexNW = 179},
            new TileTemplate {Name = "Orange Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 180, ImageIndexSE = 180, ImageIndexNE = 181, ImageIndexSW = 182, ImageIndexNW = 183},
            new TileTemplate {Name = "Paleblue Hatchback", Type = TemplateType.Car, ImageIndex = 184, ImageIndexSE = 184, ImageIndexNE = 185, ImageIndexSW = 186, ImageIndexNW = 187},
            new TileTemplate {Name = "Paleblue Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 188, ImageIndexSE = 188, ImageIndexNE = 189, ImageIndexSW = 190, ImageIndexNW = 191},
            new TileTemplate {Name = "Palewhite Hatchback", Type = TemplateType.Car, ImageIndex = 192, ImageIndexSE = 192, ImageIndexNE = 193, ImageIndexSW = 194, ImageIndexNW = 195},
            new TileTemplate {Name = "Palewhite Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 196, ImageIndexSE = 196, ImageIndexNE = 197, ImageIndexSW = 198, ImageIndexNW = 199},
            new TileTemplate {Name = "Purple Hatchback", Type = TemplateType.Car, ImageIndex = 200, ImageIndexSE = 200, ImageIndexNE = 201, ImageIndexSW = 202, ImageIndexNW = 203},
            new TileTemplate {Name = "Purple Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 204, ImageIndexSE = 204, ImageIndexNE = 205, ImageIndexSW = 206, ImageIndexNW = 207},
            new TileTemplate {Name = "Red Hatchback", Type = TemplateType.Car, ImageIndex = 208, ImageIndexSE = 209, ImageIndexNE = 210, ImageIndexSW = 211, ImageIndexNW = 212},
            new TileTemplate {Name = "Red Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 212, ImageIndexSE = 212, ImageIndexNE = 213, ImageIndexSW = 214, ImageIndexNW = 215},
            new TileTemplate {Name = "White Hatchback", Type = TemplateType.Car, ImageIndex = 216, ImageIndexSE = 216, ImageIndexNE = 217, ImageIndexSW = 218, ImageIndexNW = 219},
            new TileTemplate {Name = "Yellow Hatchback", Type = TemplateType.Car, ImageIndex = 220, ImageIndexSE = 220, ImageIndexNE = 221, ImageIndexSW = 222, ImageIndexNW = 223},
            new TileTemplate {Name = "Yellow Roofed Hatchback", Type = TemplateType.Car, ImageIndex = 224, ImageIndexSE = 224, ImageIndexNE = 225, ImageIndexSW = 226, ImageIndexNW = 227},
            new TileTemplate {Name = "White Test Van", Type = TemplateType.Car, ImageIndex = 228, ImageIndexSE = 228, ImageIndexNE = 229, ImageIndexSW = 230, ImageIndexNW = 231},
        };
        public static List<TileTemplate> DESIGNTEMPLATES_BUILDINGS = new List<TileTemplate> {
            new TileTemplate {Name = "Baracks", Type = TemplateType.ModernBuilding, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 25},
            new TileTemplate {Name = "Factory 1", Type = TemplateType.ModernBuilding, ImageIndex = 1, ImageIndexSE = 1, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 26},
            new TileTemplate {Name = "Factory 2", Type = TemplateType.ModernBuilding, ImageIndex = 2, ImageIndexSE = 2, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 27},
            new TileTemplate {Name = "Factory 3", Type = TemplateType.ModernBuilding, ImageIndex = 3, ImageIndexSE = 3, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 28},
            new TileTemplate {Name = "Finance 1", Type = TemplateType.ModernBuilding, ImageIndex = 4, ImageIndexSE = 4, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 29},
            new TileTemplate {Name = "Finance 2", Type = TemplateType.ModernBuilding, ImageIndex = 5, ImageIndexSE = 5, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 30},
            new TileTemplate {Name = "Finance 3", Type = TemplateType.ModernBuilding, ImageIndex = 6, ImageIndexSE = 6, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 31},
            new TileTemplate {Name = "Apts 5 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 7, ImageIndexSE = 7, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 32},
            new TileTemplate {Name = "Office", Type = TemplateType.ModernBuilding, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 33},
            new TileTemplate {Name = "School", Type = TemplateType.ModernBuilding, ImageIndex = 9, ImageIndexSE = 9, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 34},
            new TileTemplate {Name = "Apts 7 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 10, ImageIndexSE = 10, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 35},
            new TileTemplate {Name = "Apts 6 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 11, ImageIndexSE = 11, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 36},
            new TileTemplate {Name = "Apts 3 Floors", Type = TemplateType.ModernBuilding, ImageIndex = 12, ImageIndexSE = 12, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 37},
            new TileTemplate {Name = "Tower 1", Type = TemplateType.ModernBuilding, ImageIndex = 13, ImageIndexSE = 13, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 38},
            new TileTemplate {Name = "Tower 2", Type = TemplateType.ModernBuilding, ImageIndex = 14, ImageIndexSE = 14, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 39},
            new TileTemplate {Name = "House 2 Stories", Type = TemplateType.ModernBuilding, ImageIndex = 15, ImageIndexSE = 15, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 16},
            new TileTemplate {Name = "Store Building", Type = TemplateType.ModernBuilding, ImageIndex = 17, ImageIndexSE = 17, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 18},
            new TileTemplate {Name = "House 2", Type = TemplateType.ModernBuilding, ImageIndex = 19, ImageIndexSE = 19, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 20},
            new TileTemplate {Name = "House 3", Type = TemplateType.ModernBuilding, ImageIndex = 21, ImageIndexSE = 21, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 22},
            new TileTemplate {Name = "House 4", Type = TemplateType.ModernBuilding, ImageIndex = 23, ImageIndexSE = 23, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 24},
            new TileTemplate {Name = "Fire Department", Type = TemplateType.ModernBuilding, ImageIndex = 40, ImageIndexSE = 40, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 41},
            new TileTemplate {Name = "Hospital", Type = TemplateType.ModernBuilding, ImageIndex = 42, ImageIndexSE = 42, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 43},
            new TileTemplate {Name = "Police Station", Type = TemplateType.ModernBuilding, ImageIndex = 44, ImageIndexSE = 44, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 45},
            new TileTemplate {Name = "School 2", Type = TemplateType.ModernBuilding, ImageIndex = 46, ImageIndexSE = 46, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 47},
            new TileTemplate {Name = "Tower 3", Type = TemplateType.ModernBuilding, ImageIndex = 48, ImageIndexSE = 48, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 49},
            new TileTemplate {Name = "Tree 1", Type = TemplateType.Nature, ImageIndex = 50, ImageIndexSE = 50, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 51},
            new TileTemplate {Name = "Tree 2", Type = TemplateType.Nature, ImageIndex = 52, ImageIndexSE = 52, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 53},
            new TileTemplate {Name = "Tree 3", Type = TemplateType.Nature, ImageIndex = 54, ImageIndexSE = 54, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 55},
            new TileTemplate {Name = "Tree 4", Type = TemplateType.Nature, ImageIndex = 56, ImageIndexSE = 56, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 57},
            //new TileTemplate {Name = "Bush", Type = TemplateType.Nature, ImageIndex = 58, ImageIndexSE = 58, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 59},
            new TileTemplate {Name = "Boligblok DarkBrick", Type = TemplateType.ModernBuilding, ImageIndex = 60, ImageIndexSE = 60, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 61},
            new TileTemplate {Name = "Tree 5", Type = TemplateType.Nature, ImageIndex = 62, ImageIndexSE = 62, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 63},
            new TileTemplate {Name = "Boligblok Brick", Type = TemplateType.ModernBuilding, ImageIndex = 64, ImageIndexSE = 64, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 65},
            new TileTemplate {Name = "Boligblok Red", Type = TemplateType.ModernBuilding, ImageIndex = 66, ImageIndexSE = 66, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 67},
            new TileTemplate {Name = "Boligblok White", Type = TemplateType.ModernBuilding, ImageIndex = 68, ImageIndexSE = 68, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 69},
            new TileTemplate {Name = "Boligblok Facade", Type = TemplateType.ModernBuilding, ImageIndex = 70, ImageIndexSE = 70, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 71},
            new TileTemplate {Name = "Boligblok Hjoerne", Type = TemplateType.ModernBuilding, ImageIndex = 72, ImageIndexSE = 72, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 72},
            new TileTemplate {Name = "Shed", Type = TemplateType.ModernBuilding, ImageIndex = 73, ImageIndexSE = 73, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 74},
            new TileTemplate {Name = "Mast", Type = TemplateType.Infrastructure, ImageIndex = 75, ImageIndexSE = 75, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 75},
            new TileTemplate {Name = "Shed 2", Type = TemplateType.ModernBuilding, ImageIndex = 76, ImageIndexSE = 76, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 77},
            new TileTemplate {Name = "Shed Bare", Type = TemplateType.ModernBuilding, ImageIndex = 78, ImageIndexSE = 78, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 79},
            new TileTemplate {Name = "Boligblok Gray", Type = TemplateType.ModernBuilding, ImageIndex = 80, ImageIndexSE = 80, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 81},
            new TileTemplate {Name = "Beam", Type = TemplateType.Infrastructure, ImageIndex = 82, ImageIndexSE = 82, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 83},
            new TileTemplate {Name = "Beam Horizontal", Type = TemplateType.Infrastructure, ImageIndex = 84, ImageIndexSE = 84, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 85},
            new TileTemplate {Name = "Sign Large Back", Type = TemplateType.Infrastructure, ImageIndex = 86, ImageIndexSE = 86, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 87},
            new TileTemplate {Name = "Sign Large Front", Type = TemplateType.Infrastructure, ImageIndex = 88, ImageIndexSE = 88, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 89},
            new TileTemplate {Name = "Sign Small Front", Type = TemplateType.Infrastructure, ImageIndex = 90, ImageIndexSE = 90, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 91},
            new TileTemplate {Name = "Sign Small Back", Type = TemplateType.Infrastructure, ImageIndex = 92, ImageIndexSE = 92, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 93},
            new TileTemplate {Name = "Sign Small Front 2", Type = TemplateType.Infrastructure, ImageIndex = 94, ImageIndexSE = 94, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 95},
            new TileTemplate {Name = "Tree Large Clipart", Type = TemplateType.Nature, ImageIndex = 96, ImageIndexSE = 96, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 97},
            new TileTemplate {Name = "Tree Large Oak", Type = TemplateType.Nature, ImageIndex = 98, ImageIndexSE = 98, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 99},
            new TileTemplate {Name = "Tree Large Wide", Type = TemplateType.Nature, ImageIndex = 100, ImageIndexSE = 100, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 101},
            //new TileTemplate {Name = "Shop 1", Type = TemplateType.ModernBuilding, ImageIndex = 102, ImageIndexSE = 102, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 103},
            new TileTemplate {Name = "Boligblok Red Low", Type = TemplateType.ModernBuilding, ImageIndex = 104, ImageIndexSE = 104, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 105},
            new TileTemplate {Name = "Boligblok Yellow Brick", Type = TemplateType.ModernBuilding, ImageIndex = 106, ImageIndexSE = 106, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 107},
            new TileTemplate {Name = "Boligblok Tagpap", Type = TemplateType.ModernBuilding, ImageIndex = 108, ImageIndexSE = 108, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 109},
            new TileTemplate {Name = "Recharge Station", Type = TemplateType.ModernBuilding, ImageIndex = 110, ImageIndexSE = 110, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 111},
            new TileTemplate {Name = "HQ Upgrade 1", Type = TemplateType.ModernBuilding, ImageIndex = 112, ImageIndexSE = 112, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 113},
            new TileTemplate {Name = "HQ Upgrade 2", Type = TemplateType.ModernBuilding, ImageIndex = 114, ImageIndexSE = 114, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 115},
            new TileTemplate {Name = "HQ Upgrade 3", Type = TemplateType.ModernBuilding, ImageIndex = 116, ImageIndexSE = 116, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 117},
            new TileTemplate {Name = "HQ Upgrade 4", Type = TemplateType.ModernBuilding, ImageIndex = 118, ImageIndexSE = 118, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 119},
            new TileTemplate {Name = "Hospital Upgrade 1", Type = TemplateType.ModernBuilding, ImageIndex = 120, ImageIndexSE = 120, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 121},
            new TileTemplate {Name = "Hospital Upgrade 2", Type = TemplateType.ModernBuilding, ImageIndex = 122, ImageIndexSE = 122, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 123},
            new TileTemplate {Name = "Hospital Upgrade 3", Type = TemplateType.ModernBuilding, ImageIndex = 124, ImageIndexSE = 124, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 125},
            new TileTemplate {Name = "Hospital Upgrade 4", Type = TemplateType.ModernBuilding, ImageIndex = 126, ImageIndexSE = 126, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 127},
            new TileTemplate {Name = "Legal Upgrade 1", Type = TemplateType.ModernBuilding, ImageIndex = 128, ImageIndexSE = 128, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 129},
            new TileTemplate {Name = "Legal Upgrade 2", Type = TemplateType.ModernBuilding, ImageIndex = 130, ImageIndexSE = 130, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 131},
            new TileTemplate {Name = "Legal Upgrade 3", Type = TemplateType.ModernBuilding, ImageIndex = 132, ImageIndexSE = 132, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 133},
            new TileTemplate {Name = "Legal Upgrade 4", Type = TemplateType.ModernBuilding, ImageIndex = 134, ImageIndexSE = 134, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 135},
            new TileTemplate {Name = "Workshop Upgrade 1", Type = TemplateType.ModernBuilding, ImageIndex = 136, ImageIndexSE = 136, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 137},
            new TileTemplate {Name = "Workshop Upgrade 2", Type = TemplateType.ModernBuilding, ImageIndex = 138, ImageIndexSE = 138, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 139},
            new TileTemplate {Name = "Workshop Upgrade 3", Type = TemplateType.ModernBuilding, ImageIndex = 140, ImageIndexSE = 140, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 141},
            new TileTemplate {Name = "Workshop Upgrade 4", Type = TemplateType.ModernBuilding, ImageIndex = 142, ImageIndexSE = 142, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 143},
        };
        public static List<TileTemplate> DESIGNTEMPLATES_LIGHTS = new List<TileTemplate> {
            new TileTemplate {Name = "Frontside Car & Walk", Type = TemplateType.LightFront, ImageIndex = 0, ImageIndexSE = 0, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 1},
            new TileTemplate {Name = "Backside Car & Walk", Type = TemplateType.LightBack, ImageIndex = 6, ImageIndexSE = 6, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 7},
            new TileTemplate {Name = "Frontside Car & backside Walk", Type = TemplateType.LightFront, ImageIndex = 8, ImageIndexSE = 8, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 9},
            new TileTemplate {Name = "Backside Car & frontside Walk", Type = TemplateType.LightFront, ImageIndex = 14, ImageIndexSE = 14, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 15},
            new TileTemplate {Name = "Single Light", Type = TemplateType.StaticLight, ImageIndex = 18, ImageIndexSE = 18, ImageIndexNE = 19, ImageIndexSW = 20, ImageIndexNW = 21},
            new TileTemplate {Name = "Double Light", Type = TemplateType.StaticLight, ImageIndex = 22, ImageIndexSE = 22, ImageIndexNE = -1, ImageIndexSW = -1, ImageIndexNW = 23},
        };
        public static Map LoadMap(string filename)
        {
            try
            {
                Map map = new Map();
                using (Stream stream = File.Open(filename, FileMode.Open))
                {
                    IFormatter formatter = new BinaryFormatter();
                    map = (Map)formatter.Deserialize(stream);
                }
                return map;
            }
            catch
            {
                MessageBox.Show("Failed to load map", "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                //Debug.WriteLine("Failed to load map");
                return null;
            }
        }
        public static void SaveMap(string filename, Map map)
        {
            try
            {
                using Stream stream = File.Open(filename, FileMode.Create);
                IFormatter formatter = new BinaryFormatter();
                formatter.Serialize(stream, map);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Failed to save map: " + ex.Message, "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                //Debug.WriteLine("Failed to save map");                
                return;
            }
        }
        public static Map LoadMapXML(string filename)
        {
            try
            {
                Map map = new Map();
                using (System.IO.Stream stream = System.IO.File.Open(filename, System.IO.FileMode.Open))
                {
                    var serializer = new XmlSerializer(typeof(Map));
                    map = (Map)serializer.Deserialize(stream);
                }
                return map;
            }
            catch (Exception)
            {
                MessageBox.Show("Failed to load map", "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        public static void SaveMapXML(string filename, Map map)
        {
            try
            {
                using System.IO.Stream stream = System.IO.File.Open(filename, System.IO.FileMode.Create);
                var serializer = new XmlSerializer(typeof(Map));
                serializer.Serialize(stream, map);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Failed to save map: " + ex.Message, "Critical Error", MessageBoxButton.OK, MessageBoxImage.Error);
                return;
            }
        }
        public static void DrawMap(Map map, Canvas canvas, bool drawCars, bool drawBuildings, bool drawLights)
        {
            canvas.Children.Clear();
            int mapWidth = map.TileMap.GetLength(0);
            int mapHeight = map.TileMap.GetLength(1);
            canvas.Width = (mapWidth + .5) * map.TileWidth;
            canvas.Height = (mapHeight + 1) * (map.TileHeight / 2);
            //First draw core tiles
            for (int y = 0; y < mapHeight; y++)
            {
                for (int x = 0; x < mapWidth; x++)
                {
                    try
                    {
                        var tile = map.TileMap[x, y];
                        var img = DrawTile(canvas, tile, map.TileWidth, map.TileHeight);
                        //Groundtiles have no opacity property so we reuse it, if there is already an image attached, otherwise we would have to render the entire map again
                        if (tile.CurrentImage != null)
                            img.Opacity = tile.CurrentImage.Opacity;
                        tile.CurrentImage = img;
                    }
                    catch (Exception)
                    {
                        string fileName = string.Format("{0}\\{1}", LOCATION_TILES, "missing.png");
                        DrawTileFromResource(canvas, x, y, map.TileWidth, map.TileHeight, fileName);//create a special image for missing
                    }
                }
            }
            //Draw Cars as they must go behind buildings and lights
            if (drawCars)
            {
                foreach (ImageTile car in map.Cars)
                {
                    string fileName = string.Format("{0}\\{1}{2}", LOCATION_CARS, CARS[car.ImageIndex], ".png");
                    InsertImageTile(canvas, fileName, car);
                }
            }
            //Draw Buildings in middle layer
            if (drawBuildings)
            {
                foreach (ImageTile building in map.Buildings)
                {
                    string fileName = string.Format("{0}\\{1}{2}", LOCATION_BUILDINGS, BUILDINGS[building.ImageIndex], ".png");
                    InsertImageTile(canvas, fileName, building);
                }
            }
            //Draw Lights in front of everything else
            if (drawLights)
            {
                foreach (ImageTile pole in map.Lights)
                {
                    string fileName = string.Format("{0}\\{1}{2}", LOCATION_LIGHTS, LIGHTS[pole.ImageIndex], ".png");
                    InsertImageTile(canvas, fileName, pole);
                }
            }
        }
        public static Image DrawTileFromResource(Canvas canvas, int mapX, int mapY, int tileWidth, int tileHeight, string filename)
        {
            int xPos = tileWidth * mapX;
            if (mapY % 2 != 0)
                xPos = tileWidth * mapX + tileWidth / 2;
            int yPos = tileHeight / 2 * mapY;
            var img = AddImage(canvas, filename, xPos, yPos);
            img.Tag = new Point(mapX, mapY);//Store the original map x,y in the image tag
            return img;
        }
        public static Image AddImage(Canvas canvas, string fileName, double X, double Y)
        {
            Image ctrl = new Image
            {
                Source = new BitmapImage(new Uri(fileName))
            };
            canvas.Children.Add(ctrl);
            Canvas.SetLeft(ctrl, X);
            Canvas.SetTop(ctrl, Y);
            return ctrl;
        }
        public static BitmapImage GetTileImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_TILES, TILES[imageIndex])));
        }
        public static BitmapImage GetCarImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_CARS, CARS[imageIndex])));
        }
        public static BitmapImage GetBuildingImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_BUILDINGS, BUILDINGS[imageIndex])));
        }
        public static BitmapImage GetLightImage(int imageIndex)
        {
            return new BitmapImage(new Uri(string.Format("{0}\\{1}.png", LOCATION_LIGHTS, LIGHTS[imageIndex])));
        }
        public static int GetPreviousTemplateImageIndex(TileTemplate template)
        {
            //Sequence: ImageIndexSE, ImageIndexNE, ImageIndexSW, ImageIndexNW
            if (template.ImageIndex == template.ImageIndexSE && template.ImageIndexNW >= 0)
                return template.ImageIndexNW;
            else if (template.ImageIndex == template.ImageIndexNW && template.ImageIndexSW >= 0)
                return template.ImageIndexSW;
            else if (template.ImageIndex == template.ImageIndexSW && template.ImageIndexNE >= 0)
                return template.ImageIndexNE;
            else
                return template.ImageIndexSE;
        }
        public static int GetNextTemplateImageIndex(TileTemplate template)
        {
            //Sequence: ImageIndexSE, ImageIndexNE, ImageIndexSW, ImageIndexNW
            if (template.ImageIndex == template.ImageIndexSE)
            {
                if (template.ImageIndexNE >= 0)
                    return template.ImageIndexNE;
                else if (template.ImageIndexSW >= 0)
                    return template.ImageIndexSW;
                else
                    return template.ImageIndexNW;
            }
            else if (template.ImageIndex == template.ImageIndexNE && template.ImageIndexSW >= 0)
                return template.ImageIndexSW;
            else if (template.ImageIndex == template.ImageIndexSW && template.ImageIndexNW >= 0)
                return template.ImageIndexNW;
            else
                return template.ImageIndexSE;
        }

        private static Image DrawTile(Canvas canvas, GroundTile tile, int tileWidth, int tileHeight)
        {
            string filename = string.Format("{0}\\{1}{2}", LOCATION_TILES, TILES[tile.TileIndex], ".png");
            int xPos = tileWidth * tile.MapX;
            if (tile.MapY % 2 != 0)
                xPos = tileWidth * tile.MapX + tileWidth / 2;
            int yPos = tileHeight / 2 * tile.MapY;
            var img = AddImage(canvas, filename, xPos, yPos);
            img.Tag = tile;//Store the original groundtile in the image tag
            return img;
        }
        private static void InsertImageTile(Canvas canvas, string fileName, ImageTile imageTile)
        {
            var img = AddImage(canvas, fileName, imageTile.StartXPosition, imageTile.StartYPosition);
            img.Tag = imageTile;
            img.Opacity = imageTile.Opacity;
            imageTile.CurrentImage = img;
        }

        public static Point ScreenPositionFromMapCoords(Map map, int mapX, int mapY)
        {
            int xPos = map.TileWidth * mapX;
            if (mapY % 2 != 0)
                xPos = map.TileWidth * mapX + map.TileWidth / 2;
            int yPos = map.TileHeight / 2 * mapY;
            return new Point(xPos, yPos);
        }
        public static Point MapCoordsFromScreenPosition(Map map, double x, double y)
        {
            //Calculate approxmate map coordinates from the specified screen position
            int mapWidth = map.TileMap.GetLength(0);
            int mapHeight = map.TileMap.GetLength(1);
            int mapX = (int)(x / map.TileWidth);
            int mapY = (int)(y / (map.TileHeight / 2));
            //Bounds checking
            if (mapX >= mapWidth)
                mapX = mapWidth - 1;
            if (mapY >= mapHeight)
                mapY = mapHeight - 1;

            //check at mapX
            if (PointInTile(x, y, map.TileMap[mapX, mapY], map.TileWidth, map.TileHeight))
                return new Point(mapX, mapY);
            else if (mapY > 0 && PointInTile(x, y, map.TileMap[mapX, mapY - 1], map.TileWidth, map.TileHeight))
                return new Point(mapX, mapY - 1);
            else if (mapY < mapWidth - 1 && PointInTile(x, y, map.TileMap[mapX, mapY + 1], map.TileWidth, map.TileHeight))
                return new Point(mapX, mapY + 1);
            //check at mapX - 1
            else if (mapX > 0)
            {
                if (PointInTile(x, y, map.TileMap[mapX - 1, mapY], map.TileWidth, map.TileHeight))
                    return new Point(mapX - 1, mapY);
                else if (mapY > 0 && PointInTile(x, y, map.TileMap[mapX - 1, mapY - 1], map.TileWidth, map.TileHeight))
                    return new Point(mapX - 1, mapY - 1);
                else if (mapY < mapWidth - 1 && PointInTile(x, y, map.TileMap[mapX - 1, mapY + 1], map.TileWidth, map.TileHeight))
                    return new Point(mapX - 1, mapY + 1);
            }
            //we are outside the map
            return new Point(-1, -1);
        }
        private static bool PointInTile(double x, double y, GroundTile tile, int tileWidth, int tileHeight)
        {
            //get the rectangular bounds of the tile (remember to offset x-pos when mapY is Odd)
            int xOffset = tileWidth * tile.MapX;
            if (tile.MapY % 2 != 0)
                xOffset = tileWidth * tile.MapX + tileWidth / 2;
            int yOffset = tileHeight / 2 * tile.MapY;

            var p1 = new Point(xOffset, yOffset + tileHeight / 2);
            var p2 = new Point(xOffset + tileWidth / 2, yOffset);
            var p3 = new Point(xOffset + tileWidth / 2, yOffset + tileHeight);
            if (GeometryHelpers.PointInParralellogram(new Point(x, y), p1, p2, p3))
                return true;
            else
                return false;
        }
    }
}
