﻿using GameCore;
using System.Windows;
using System.Windows.Controls;

namespace MapMaker
{
    /// <summary>
    /// Interaction logic for dlgNewMap.xaml
    /// </summary>
    public partial class dlgNewMap : Window
    {
        int[] _fillerTileIndexes = new[] { 0, 1, 2, 3, 34, 35, 36, 37, 38, 39, 56, 101 };

        public int MapWidth { get; set; }
        public int MapHeight { get; set; }
        public bool FillBack { get; set; }
        public int FillBackIndex { get; set; }

        public dlgNewMap()
        {
            InitializeComponent();
            MapWidth = 10;
            MapHeight = 20;
            InitializeFillerTileCombo();
        }

        private void InitializeFillerTileCombo()
        {
            foreach (int index in _fillerTileIndexes)
            {
                var bmp = TrafficScene.GetTileImage(index);
                var img = new Image { Source = bmp };
                cmbBackTiles.Items.Add(img);
            }
        }

        private void BtnOkClick(object sender, RoutedEventArgs e)
        {
            if (cmbBackTiles.SelectedIndex >= 0)
                FillBackIndex = _fillerTileIndexes[cmbBackTiles.SelectedIndex];
            else
                FillBackIndex = 0;
            if (int.TryParse(txtMapWidth.Text, out int width) == false)
                width = 10;
            if (int.TryParse(txtMapHeight.Text, out int height) == false)
                height = 20;

            MapWidth = width;
            MapHeight = height;
            FillBack = chkFillBack.IsChecked == true;
            DialogResult = true;
            Close();
        }
        private void BtnCancelClick(object sender, RoutedEventArgs e)
        {
            Close();
        }
    }
}
